class Util {

  static deepObfuscateValue(payload, fields) {
    if (this.isObject(payload)) {
      const copy = {};

      Object.keys(payload).forEach((key) => {
        copy[key] = fields.includes(key) ? '[HIDDEN]' : this.deepObfuscateValue(payload[key], fields);
      });

      return copy;
    } else if (this.isArray(payload)) {
      return payload.map(e => this.deepObfuscateValue(e, fields));
    }

    return payload;
  }

  static isObject(obj) {
    const type = typeof obj;

    return (type === 'function' || type === 'object') && !!obj;
  }

  static isArray(obj) {
    return toString.call(obj) === '[object Array]';
  }


}


module.exports = Util;
